Start Page

Welcome! Thanks for using Total .NET SourceBook. We hope that it helps you in your .NET Development efforts. This help file is designed to provide you with the information you need to get up and running quickly.

Key Topics

  • What Is Total .NET SourceBook?

  • Why Use Total .NET SourceBook?

  • Running the Program

  • Adding Your Own Items

  • How Total .NET SourceBook Integrates with Visual Studio .NET

  • Code Webservice Overview

  • Support Resources

More .NET Products to Help You

Visit www.fmsinc.com/dotnet for the latest information on our complete line of .NET Developer solutions. Get up-to-date product information, tips and tricks, or subscribe to our email newsletter for .NET development.

Contact FMS

www.fmsinc.com
For more information: info@fmsinc.com
Technical Support: support@fmsinc.com
Product Updates: www.fmsinc.com/free/updates


What Is Total .NET SourceBook?

Total .NET SourceBook is the ultimate code library for .NET developers, teams, and enterprises. It provides the best collection of ready-to-use code snippets, classes, how-to’s, and articles. It also allows you to manage your own code using its fully searchable code repository.

Total .NET SourceBook functions in two modes: Code Explorer and Visual Studio .NET Add-In. The Code Explorer is a standalone program that provides access to all of the program’s features, allowing you to:

  • View, edit, and delete existing code items.

  • Add new code items and code databases.

  • Perform advanced searches on code databases.

  • Export code to a file or to the clipboard.

  • Get new and updated code from the Code Webservice.

The Total .NET SourceBook Add-In provides you with easy access to Total .NET SourceBook code without leaving Visual Studio .NET. The add-in lets you:

  • Drag code out of your project directly into the Total .NET SourceBook database.

  • View, edit, and delete existing code items and notes.

  • Perform text searches within code items.

  • Export code directly into your project.

See also:

  • Why Use Total .NET SourceBook?

  • Visit our Web Site


Why Use Total .NET SourceBook?

Total .NET SourceBook is a complete collection of ready to use .NET programming code, with C# and Visual Basic .NET versions. A wide range of .NET programming areas is covered, and new code keeps coming through the FMS Code Webservice!

Regardless of your level of programming expertise, you will find code in the library that saves you time and enhances your knowledge. Novice and intermediate programmers will find the product useful as training material—the articles and how-to’s will help them get up to speed much more efficiently. Advanced programmers will benefit from the more complex code, which will save time and boost knowledge. And because the library code is open and available for modification, experts can customize the code to meet their specific needs.

In addition to the valuable code library, Total .NET SourceBook acts as a code repository. The Code Explorer makes finding and organizing your own code a snap, plus you can easily add code and notes from your projects, from other developers, or from the FMS Code Webservice. Best of all, you can share code databases within your organization, so developers don’t have to waste time creating code that someone else has already written. The Total .NET SourceBook Add-in even makes it a snap to move code between your repository and your applications – simply drag and drop!

See also:

  • What Is Total .NET SourceBook?

  • Visit our Web Site


Visit our Web Site

FMS is constantly developing new and better developer solutions. Total .NET SourceBook is part of our complete line of products designed specifically for the .NET developer. Please take a moment to visit us online at www.fmsinc.com/dotnet to find out about new products and updates.

Product Announcements and Press Releases

Read the latest information on new products, new versions, and future products. Press releases are available the same day they are sent to the press. Sign up in our Feedback section to have press releases automatically sent to you via email.

Product Descriptions and Demos

Detailed descriptions for all of our products are available. Each product has its own page with information about features and capabilities. Demo versions for most of our products are also available.

Product Registration

Register your copy of Total .NET SourceBook on-line. Be sure to select the email notification option so you can be contacted when updates are available or news is released. You must be registered to receive technical support.

Product Updates

FMS is committed to quality software. When we find problems in our products, we fix them and post the new builds on our web site. Check our Product Updates page in the Technical Support area for the latest build.

Utilities and Free Software

Download free demos and utilities, including add-ins and developer tools.

Technical Papers

FMS personnel often speak at conferences and write magazine articles, papers, and books. Copies and portions of this information are available to you online. Learn about our latest ideas and tricks for using Visual Studio .NET more effectively.

Newsgroups

Share your experiences, learn from others, and ask your questions in our virtual community. Visit our newsgroups at:

www.fmsinc.com/support/newsgrp.htm

Or see our web site for additional instructions.

Links to Other Development Sites

Jump to other locations, including newsgroups, user group home pages, and other sites with Visual Studio .NET news, techniques, and related services.


System Requirements

Total .NET SourceBook has the following system requirements:

  1. Microsoft Visual Studio .NET.

  2. Approximately 25 MB Free Disk Space.

  3. Microsoft Windows 2000 Professional, Windows 2000 Server, Windows 2000 Advanced Server, Windows XP Professional, or Windows NT 4. Total .NET SourceBook is not supported under Windows 95, 98, or ME.

  4. Pentium II-class processor, 450 MHz or higher (Pentium III-class processor, 800 MHZ recommended).

  5. A minimum of 192 MB of RAM (more is always better).

See also:

  • Installing the Program

  • Check for Updates

  • Uninstalling the Program


Installing the Program

Total .NET SourceBook is installed using an automated Windows Installer setup program. Generally, all you have to do is run setup, specify some values, and you’re done. This section contains complete information on installing the program.

To install Total .NET SourceBook, follow these steps:

  1. Locate and run the setup program.

  2. When prompted, enter your registration information and product key (serial number).

  3. Specify the destination directory for the files.

  4. Be sure to read the README.HTM file for any late breaking news that is not included in this User Guide.

When you install the product, be sure to enter your correct serial number, user name and organization. This information is required for the Code Webservice to work (see The Code Webservice)

See also:

  • System Requirements

  • Check for Updates

  • Uninstalling the Program


Check for Updates

After Installing the Program, you should check the FMS website to see if any product updates are available. To do this, visit:

www.fmsinc.com/support

And visit the product updates section.

You should also check the FMS Code Webservice to download the latest code. See The Code Webservice for more information.

See also:

  • System Requirements

  • Installing the Program

  • Uninstalling the Program


Uninstalling the Program

If you need to uninstall Total .NET SourceBook, follow these steps:

  1. From the Windows Start Menu, select Control Panel.

  2. From the Control Panel window, select Add/Remove Programs.

  3. Select FMS Total .NET SourceBook from the list of installed programs, and press the Change/Remove button.

  4. Follow the onscreen prompts to uninstall the product.

Note that uninstalling Total .NET SourceBook does not remove any of your code databases, such as FMSCode.MDB or code databases you have created

See also:

  • System Requirements

  • Installing the Program

  • Check for Updates


Running the Program

To open the SourceBook Code Explorer, run FMS.SourceBook.exe from your installation directory or from the shortcut in the Windows Start menu:

Start, Programs, FMS .NET Suite, Total .NET SourceBook, SourceBook

When you run the program for the first time, the FMS code database (FMSCode.MDB) is created in your My Documents folder, and the code is loaded into the explorer.

The FMS Code Database is created in the My Documents folder for the user who is logged in when the program is first run. If you need to recover the version of the database that was originally installed, copy FMSCode.MDB from the Total .NET SourceBook installation directory, in the Resources folder. Be sure to copy this database into a new location, and then open it using the Code Explorer.

See also:

  • The Start Page

  • The Menu and Toolbar

  • The Treeview

  • The Details Pane

  • The Search Results


The Start Page

When you load the Code Explorer, the Start Page appears:

Start Page

This page provides links to common tasks and help topics, displays the available Code Webservice updates, and shows late-breaking development news and resources.

By default, the Start Page appears every time you run the Code Explorer. If you do not want to see the Start Page when you start the program, disable this option by going to Tools, Settings and deselecting "Always Start in Start Page" (on the General Tab). See Tools Menu for more information.

See also:

  • Running the Program

  • The Menu and Toolbar

  • The Treeview

  • The Details Pane

  • The Search Results


The Menu and Toolbar

Total .NET SourceBook provides many features that make it easy to find and manage code. All of these features are available from the Code Explorer menu, and shortcuts for many options are available from the toolbar:

Menu and Toolbar

The following menus are available:

  • File Menu

  • Edit Menu

  • View Menu

  • Search Menu

  • Tools Menu

  • Help Menu

See also:

  • Running the Program

  • The Start Page

  • The Treeview

  • The Details Pane

  • The Search Results


File Menu

File Menu

Open Database: Opens a code database.

Close Database: Closes the code database that has focus in the treeview.

New Database: Creates a new code database.

Import SourceBook XML: Imports a code item or folder from an XML file into the folder or database that has focus in the treeview.

Import File: Imports the contents of a file into the folder or database that has focus in the treeview.

Export SourceBook XML: Exports the folder or code item that has focus to an XML file

Export File: Exports the code item that has focus to a text file, with options to include multiple language versions, notes, and other fields.

Recent Databases: Displays a list of recent code databases.

Exit: Closes Total .NET SourceBook.

See also:

  • The Menu and Toolbar


Edit Menu

Edit Menu

New Item: Creates a new code item in the database or folder that has focus in the treeview

New Folder: Creates a new folder in the database or folder that has focus in the treeview.

Edit Item: Opens the edit form for the folder or code item that has focus in the treeview.

Delete Item: Deletes the folder or code item that has focus in the treeview.

See also:

  • The Menu and Toolbar


View Menu

View Menu

Expand All: Expands all nodes in the treeview.

Collapse All: Collapses all nodes in the treeview.

Refresh Database: Refreshes the database that has focus in the treeview to ensure that all items are up-to-date. Use the Refresh menu item when multiple developers are using the same database, or when you are making changes through the Total .NET SourceBook add-in.

See also:

  • The Menu and Toolbar


Search Menu

Search Menu

Local Database(s): Opens the search form, which allows you to search local databases.

Code Webservice: Displays the recent items available from the FMS Code Webservice.

See also:

  • The Menu and Toolbar


Tools Menu

Tools Menu

Settings

General Tab

Settings Form, General Tab

The General tab provides the following options:

  • Open last used databases on startup.

  • Always start in Start Page.

  • Code Webservice Date.

User Info Tab

Settings Form, User Info Tab

The User Info tab holds user-specific information: user name, email address, and copyright information. This information is useful in several situations, including:

  • When you are using Total .NET SourceBook in a multi-user environment where it is important to know who created code.

  • When you are exporting code from your installation of Total .NET SourceBook for other Total .NET SourceBook users and you want to maintain your contact and copyright information.

The information that you enter in the Settings form is used by default when you create new code items, but can be overridden on a case-by-case basis.

Database Maintenance

Provides tools for managing code databases. See Administrative Tools for more information.

See also:

  • The Menu and Toolbar


Help Menu

Help Menu

Contents: Displays the help contents.

Index: Displays the help index.

FMS On the Web: Takes you to the FMS web site.

About: Displays license, version, and copyright information for Total .NET SourceBook.

See also:

  • The Menu and Toolbar


The Treeview

The treeview provides a visual representation of the items in your code database. It allows you to view and edit multiple code databases, and offers an easy way to organize your code:

Treeview

The following sections contain important information about the Treeview:

  • Code Items

  • Organizing the Code

  • Right-Click Menu

See also:

  • Running the Program

  • The Start Page

  • The Menu and Toolbar

  • The Details Pane

  • The Search Results


Code Items

Total .NET SourceBook provides you with the flexibility to store all of your important .NET resources in one place. The following icons help you differentiate between types of items in the treeview:

Class: A ready-to-run .NET class

Code: Generic ready-to-run code in the form of a method, procedure, subroutine, etc.

Module: A Visual Basic .NET module.

Snippet: A fragment of code that illustrates a programming concept, but is not ready-to-run. Typically, snippets are bits of code that are to be integrated into a new or existing class, method, or procedure.

How-To: A combination of code and notes that illustrate the general principals of a programming task.

Item: Any generic item of information that does not fit into other categories.

WebForm: A .NET Web Form

Article: An item comprised mostly or entirely of notes, with little or no code.

XML: Any XML file.

Other: Any other item that does not fit into other categories.

See also:

  • The Treeview


Organizing Your Code

Total .NET SourceBook allows you to organize the code in the treeview to suit your needs and preferences. You can drag and drop code items to move or copy items into new locations. Just click on the item to move, and drag it into the new location.

The status bar at the bottom of the Code Explorer displays an appropriate message if you attempt to drag and drop to an invalid location. Items and folders can be dragged into folders and databases. Databases cannot be dragged.

When you drop the item, the drag/drop menu will appear:

Drag/Drop Menu

Note that there is no Undo for drag and drop operations. To move an item back to its original location, you must drag it back.

See also:

  • The Treeview

  • Managing Multiple Code Databases


Right-Click Menu

Use the right-click menu as a shortcut to access many of the useful options available in the product:

Treeview Right-Click Menu

New Item: Creates a new code item in the database or folder that has focus in the treeview.

New Folder: Creates a new folder in the database or folder that has focus in the treeview.

Edit Item: Opens the edit form for the folder or code item that has focus in the treeview.

Delete Item: Deletes the folder or code item that has focus in the treeview.

Import SourceBook XML: Imports a code item or folder from an XML file into the folder or database that has focus in the treeview.

Import File: Imports the contents of a file into the folder or database that has focus in the treeview.

Export SourceBook XML: Exports the folder or code item that has focus to an XML file.

Export File: Exports the code item that has focus to a text file, with options to include multiple language versions, notes, and other fields.

Expand All: Expands all nodes in the treeview.

Collapse All: Collapses all nodes in the treeview.

Expand Node: Expands the node that currently has focus in the treeview.

Collapse Node: the node that currently has focus in the treeview.

See also:

  • The Treeview


The Details Pane

The details pane appears to the right of the treeview, and shows the item’s information, code, notes, and details:

Details Pane

See also:

  • Running the Program

  • The Start Page

  • The Menu and Toolbar

  • The Treeview

  • The Details Pane

  • The Search Results


Information Section

The information section appears at the top of the details pane:

Details Pane, Information Section

The information section shows an overview of the item, including name, type, description, and author. It also provides options to show or hide the notes, and to show or hide the details.

See also:

  • The Details Pane


Code Tabs

Since the Microsoft .NET platform supports many languages, Total .NET SourceBook is designed to be versatile enough to support them all. The code that comes with the product includes both C# and Visual Basic .NET versions, and the program in general supports multiple languages.

The code tabs appear below the information section:

Details Pane, Code Tabs

The code tabs display the item’s code, and allow you to organize your code by language. Tabs containing code are displayed with the [image] icon, so you can easily identify where your code is stored.

When working with code, you may wish to consider hiding the notes and/or details sections to view the maximum amount of code in the window. To hide these sections, use the buttons found in the Information Section, at the top of the Details Pane.

Right-Click Menu

Right-click on the code tabs to access many of the useful options available in the product:

Code Right-Click Menu

Code to Clipboard: Copies the code from the tab that has focus to the Windows Clipboard.

Select All: Selects the entire contents of the tab that has focus.

Copy: Copies the selected text to the Windows Clipboard.

Find in Window: Searches the tab for the specified word or phrase.

Edit Item: Opens the edit form for the folder or code item that has focus in the treeview.

Export File: Exports the code item that has focus to a text file, with options to include multiple language versions, notes, and other fields.

Export SourceBook XML: Exports the folder or code item that has focus to an XML file.

Color Coding: Turns color coding on or off.

Line Numbering: Turns line numbering on or off.

Left Margin: Adds or removes a margin to the left of the code.

Visible Whitespace: Shows visible white space by showing [ [image]] for each space.

See also:

  • The Details Pane


Notes

The notes section appears below the code tabs:

Details Pane, Notes

The notes section shows information pertaining to the code item. To hide the notes, press the "Hide Notes" button in the information section.

Right-Click Menu

Right-click in the notes section to access many of the useful options available in the product:

Notes Right-Click Menu

Select All: Selects the entire contents of the tab.

Copy: Copies the selected text to the Windows Clipboard.

Export File: Exports the code item that has focus to a text file, with options to include multiple language versions, notes, and other fields.

Export SourceBook XML: Exports the folder or code item that has focus to an XML file.

Edit Item: Opens the edit form for the folder or code item that has focus in the treeview.

See also:

  • The Details Pane


Details

The details section appears at the bottom of the Details Pane:

Details Pane, Details

The details section displays author email, copyright information, created and modified dates, source, and the item GUID (a unique ID for each Total .NET SourceBook item). To hide the details, press the "Hide Details" button in the information section.

If you are not concerned with viewing the Details section at all times, consider hiding it to allow more room for the Code Tabs and the Notes.

See also:

  • The Details Pane


The Search Results

The bottom of the main form shows the results of the last search you performed:

Search Results

The search grid shows the item icon, name, description, and database for each item found. Click on any row in the results to jump to that item in the treeview.

To perform a quick text search, type the search value in the "Search for" field below the Treeview:

For advanced options, click the Advanced Search link.

See also:

  • Running the Program

  • The Start Page

  • The Menu and Toolbar

  • The Treeview

  • The Details Pane


The Importance of Backups

If you use Total .NET SourceBook to manage your code, you must make regular backups of your code databases. The best way to do this is to use your current backup process on every code database that you create or modify.

Total .NET SourceBook databases use the extension ".MDB". The entire path of the database can be seen in the Code Explorer’s Information Section when you have the database selected in the Treeview (the FMS Code Database, FMSCode.MDB is located by default in your My Documents folder).

Your code is invaluable. It represents a huge amount of time and effort, and should be backed up regularly.

Ensure that your code databases are part of a regular, automated backup routine. If you do not have a current backup process in place, consider using a tool that automates database maintenance on a scheduled basis, such as the FMS product Total Visual Agent. For more information, visit our web site at www.fmsinc.com.

See also:

  • Administrative Tools

  • Total .NET SourceBook Code Style

  • Exporting To and Importing From XML

  • Exporting Code to a File

  • Importing Code From a File

  • Adding Your Own Items

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Administrative Tools

Total .NET SourceBook includes a Database Maintenance form, which makes it easy to obtain information about code databases and to keep them compacted and repaired. To access the Database Maintenance form, choose Tools, Database Maintenance from the Code Explorer menu:

Database Maintenance Menu

Repair/Compact

In order to keep your code databases optimized and working properly, you should repair and compact them regularly. Press the Repair/Compact button, and browse to the location of the database. When the action is complete, you will see a notification message with a summary of the results:

Repair/Compact Summary Message

The Repair/Compact feature is an important tool for maintaining and optimizing your databases. You should determine how often to Repair/Compact your databases depending on how you use the product.

Be sure to Repair/Compact Code Databases when:

  • Your database becomes corrupt
    If you have ever worked with Jet databases, you know that database corruption is a fact of life. If your database becomes corrupt, the Repair feature is vital in recovering your data.

  • You move, add, or delete items
    As you move, add, and delete items to Code Databases, they continue to grow without using space optimally. The Compact feature compresses your database to use space efficiently, increasing the speed and decreasing the storage space needed.

If you rarely move, delete, and add items to your Code Databases, and you do not encounter database corruption, you may not need to run the repair/compact feature.

Database Information

To obtain more information about a code database, press the Information button, and browse to the location of the code database:

Database Information Form

This form displays any users who are currently logged into the database, as well as the file size, date created, last write time, and last access time.

Note that the process used to check database information will appear in the Users Currently Logged Into the Database as another instance of your user on your machine. This means that at least one entry will be shown, even if no one else is accessing the database.

See also:

  • The Importance of Backups

  • Total .NET SourceBook Code Style

  • Exporting To and Importing From XML

  • Exporting Code to a File

  • Importing Code From a File

  • Adding Your Own Items

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Total .NET SourceBook Code Style

Every experienced programmer has his or her own ideas about what constitutes good programming style. While it is not possible for the code style used in Total .NET SourceBook to satisfy all developers, you can modify all of the code in the product to suit your own preferences. Read Editing and Deleting Items for information about editing existing code items.

See also:

  • The Importance of Backups

  • Administrative Tools

  • Exporting To and Importing From XML

  • Exporting Code to a File

  • Importing Code From a File

  • Adding Your Own Items

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Exporting To and Importing From XML

You can export any folder or code item to an XML file by using the File, Export SourceBook XML menu option (or the [image] item on the toolbar). This allows you to easily share your code items with other Total .NET SourceBook users.

To import a Total .NET SourceBook XML file, click on the database or folder where you want the new item to be saved. Then use the File, Import SourceBook XML menu option (or the [image] item on the toolbar).

See also:

  • The Importance of Backups

  • Administrative Tools

  • Total .NET SourceBook Code Style

  • Exporting Code to a File

  • Importing Code From a File

  • Adding Your Own Items

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Exporting Code to a File

You can export any code item to a text file using the File, Export File menu item. The following form will appear:

Export to File

Browse to the location where you want to save the file, and press "Next." The following form allows you to specify what items are exported:

Export to File

This form shows a check box for each code tab that contains code. Select the languages that you want included in the file, and choose whether to include notes and other fields. Then, press "Next" to save the file.

See also:

  • The Importance of Backups

  • Administrative Tools

  • Total .NET SourceBook Code Style

  • Exporting To and Importing From XML

  • Importing Code From a File

  • Adding Your Own Items

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Importing Code From a File

To import code from a file, click on the database or folder where you want the new item to be saved. Then use the File, Import File menu item, or right-click and choose Import File. The following form will appear:

Import From File

Browse to the location of the file that you want to import, and press "Next." The following form allows you to choose which code tab the file imports to:

Import From File

Total .NET SourceBook reviews the contents of the file, and makes an educated guess on the code language. If it is incorrect, choose the correct language from the list. If it is correct, press "Next," and the edit form opens for your new item, with the code on the appropriate tab.

See also:

  • The Importance of Backups

  • Administrative Tools

  • Total .NET SourceBook Code Style

  • Exporting To and Importing From XML

  • Exporting Code to a File

  • Adding Your Own Items

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Adding Your Own Items

Along with including an extensive code library, Total .NET SourceBook also acts as a repository for your own code. Using Total .NET SourceBook to manage your code allows you to:

  • Stop hunting through old projects for code you know you’ve written.

  • Keep track of useful articles and code snippets that you find online.

  • Stop repeating work that you or your colleagues have already done.

  • Know where the latest version of your code is stored.

  • Add notes and copyright information to your code.

  • Use the Code Explorer to organize your code.

  • Use the Search tool to find code by keyword.

  • Share your code with other Total .NET SourceBook users.

  • Allow junior developers to learn from more experienced programmers’ code.

The following topics contain important information about adding your own items:

  • Adding New Databases

  • Adding New Folders

  • Adding New Items

See also:

  • The Importance of Backups

  • Administrative Tools

  • Total .NET SourceBook Code Style

  • Exporting To and Importing From XML

  • Exporting Code to a File

  • Importing Code From a File

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Adding New Databases

To add a new database, simply choose the File, New Database menu item, and browse to your desired location. A new code database is created, and appears in the Code Explorer Treeview.

See also:

  • Adding Your Own Items


Adding New Folders

To add a new folder, select the database or folder where you want the new folder to be created. Choose Edit, New Folder from the menu, use the [image] icon on the toolbar, or right-click and choose "New Folder," and the Item Editor will appear:

Item Editor, Folder Tab

Enter a name and description for the new folder. There are no additional settings on the Folder tab. Click on "Notes," and the Notes tab displays:

Item Editor, Notes Tab

On the Notes tab, you can enter a detailed description about the code included in the folder. Formatting options are available from the Toolbar, so you can customize the appearance of your notes.

After entering your notes, click on "Details" to move to the Details tab:

Item Editor, Details Tab

This tab allows you to specify additional settings, such as author name, email, copyright information, and the code source. It also shows the creation and last modified dates for the folder.

The Name, Email, and Copyright Information fields are filled in automatically with the text specified in the Settings form (available from the Tools, Settings menu item). You can choose to keep the default values, or to override for individual items.

After you enter the desired folder information, press "OK" to save the new folder.

See also:

  • Adding Your Own Items


Adding New Items

To add a new item, select the database or folder where you want the new item to be created. Choose Edit, New Item from the menu, use the [image] icon on the toolbar, or right-click and choose "New Item," and the Item Editor for code items will appear:

Item Editor, Code Tab

Enter a name and description for the new item. Then, choose the type of item from the "Item Type" list. The item type determines the icon that will show in the treeview.

Enter the item’s code on the appropriate code tab. If you have copied your code onto the Windows Clipboard, use the Format/Paste from Clipboard button to place the code on the appropriate tab.

When you press the Format/Paste from Clipboard button, Total .NET SourceBook reviews the contents of the file, and makes an educated guess on the code language. It also fixes code indentations.

If Total .NET SourceBook’s "educated guess" is incorrect, choose the correct tab and press "Ctrl+V" to paste the code from your clipboard.

The Code tab offers several options for customizing the appearance of the code. To access these options, right-click in the code window:

Item Editor Right-Click Menu

You can turn color coding on or off, turn line numbering on or off, show or hide the left margin, or see the visible whitespace. More information about these options is provided in Code Tabs

You can add pictures to notes simply by copying a bitmap from another window to the clipboard, and pasting it into the notes editor (similar to WordPad). However, storing bitmaps in notes is not generally recommended, since it uses up a lot of space and can adversely affect the program’s performance.

In addition to the options for customizing appearance, you can select all code in the window, copy the selected text, or perform a find or replace action.

After adding your code to the appropriate tab, click on "Notes," and the Notes tab displays:

Item Editor, Notes Tab

On the Notes tab, you can enter a detailed description about your item. Formatting options are available from the Toolbar, so you can customize the appearance of your notes.

After entering your notes, click on "Details" to move to the Details tab:

Item Editor, Details Tab

This tab allows you to specify additional settings, such as author name, email, copyright information, and the code source. It also shows the creation and last modified dates for the folder. After you enter the desired information, press "OK" to save the new item.

See also:

  • Adding Your Own Items


Editing and Deleting Items

You can edit any existing folder or code item. To edit a folder or item, select it in the treeview and choose Edit, Edit Item (or click on the [image] icon on the toolbar). The Item Editor appears, allowing you to change the code, notes, or details. The options available on the Item Editor are identical to the options available when you add a new folder or item. Read Adding Your Own Items for details.

To delete a folder or code item, simply choose Edit, Delete Item from the menu, or click on the [image] icon on the toolbar. The item is permanently deleted, and cannot be recovered.

See also:

  • The Importance of Backups

  • Administrative Tools

  • Total .NET SourceBook Code Style

  • Exporting To and Importing From XML

  • Exporting Code to a File

  • Importing Code From a File

  • Adding Your Own Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Managing Multiple Code Databases

Total .NET SourceBook provides the flexibility to manage tasks and share code resources with other developers by making it possible to create multiple code databases. For example you may want to keep your own code separate from the FMS code that is included in Total .NET SourceBook. Or you may want to create a separate code database for each project that you’re working on, and only see the code for one project at a time.

As noted in The Importance of Backups, it is very important to make regular backups of every code database that you use.

Creating a Database

To add a new database, simply choose the File, New Database menu item, and browse to your desired location.

Opening an Existing Database

To open a Total .NET SourceBook database that already exists, choose File, Open Database from the menu (or press the [image] icon on the toolbar). Browse to the location of the existing database, and press OK. The database and its code now appear in the treeview.

Closing a Code Database

If you no longer want to see a particular code database in the Total .NET SourceBook treeview, you can close the database. Simply choose File, Close Database from the menu, or click on the [image] icon on the toolbar.

Closing a database does not delete the database—it still exists in the location where it was created. You can reopen the database at any time by choosing File, Open Database from the menu.

Maintaining Databases

Total .NET SourceBook stores code in Jet Engine database files. Just like any other Jet databases, they need to be periodically repaired and compacted to maintain integrity and efficiency. See Administrative Tools for information on using the built-in Compact Repair tool.

As noted in The Importance of Backups, it is very important to make regular backups of every code database that you use. It is also important to back up your databases prior to compacting/repairing them.

See also:

  • The Importance of Backups

  • Administrative Tools

  • Total .NET SourceBook Code Style

  • Exporting To and Importing From XML

  • Exporting Code to a File

  • Importing Code From a File

  • Adding Your Own Items

  • Editing and Deleting Items

  • Searching Code Databases


Searching Code Databases

Although the Code Explorer Treeview makes it easy to locate code by category, there will no doubt be times when you can’t find what you’re looking for. The Code Explorer includes a powerful search tool that allows you to search for code by language, code type, and database. Choose Search, Local Database(s) from the menu, click on the [image] icon on your toolbar, or use the keyboard shortcut Crtl+F to show the Advanced Search form:

Search Tool

The Advanced Search tool allows you to search with the following options:

  • Match Case: Make your search case-sensitive.

  • Partial Match/Match Entire Field: Use the Partial Match option to find the search string anywhere in the field. Use the Match Entire Field option if you know the entire contents of the field.

  • Language Filter: Select which language tabs to search.

  • Type Filter: Select which code types to search.

See The Search Results for more information about using the search results.


How Total .NET SourceBook Integrates with Visual Studio .NET

We have designed Total .NET SourceBook to be simple enough to use every time you use Visual Studio .NET. To meet this goal, we have aimed to organize the product’s features in a way that doesn’t interfere with other parts of your IDE. All functionality is accessible from toolwindows that can be docked or undocked and shown or hidden just like any Visual Studio .NET toolbar.

See also:

  • Launching the Add-In

  • Navigator Toolwindow

  • Item Preview Toolwindow

  • Item Notes Toolwindow

  • Search Results Toolwindow

  • Editing Item Properties

  • Using the Add-In

  • Getting Code from Visual Studio into Total .NET SourceBook

  • Getting Code into Visual Studio .NET


Launching the Add-In

When you install Total .NET SourceBook and run Visual Studio .NET, the add-in is automatically loaded into the IDE and the Total .NET SourceBook toolwindow appears. With this default behavior, you do not need to open or start the product—it is automatically loaded whenever you start Visual Studio .NET.

If the toolwindow is not open, one of the following conditions is true:

  • The toolwindow was explicitly closed (using the [X] close button).

  • The product’s add-in load status has been changed from its default value of "Startup" (see Changing Add-In Settings below for details).

If the toolwindow is not open, select Tools, FMS Total .NET Suite, Total .NET SourceBook, Show Window from the Visual Studio .NET menu.

Changing Add-In Settings

Total .NET SourceBook is implemented as an add-in to Visual Studio .NET. You can change the program’s load behavior by using the Visual Studio .NET add-in manager. To open this manager, select Tools, Add-In Manager from the Visual Studio .NET menu.

Visual Studio .NET Add-in Manager

To tell Visual Studio .NET to load Total .NET SourceBook every time it starts, check the Startup checkbox. If you do not want this auto load behavior, uncheck Startup.

See also:

  • How Total .NET SourceBook Integrates with Visual Studio .NET

  • Navigator Toolwindow

  • Item Preview Toolwindow

  • Item Notes Toolwindow

  • Search Results Toolwindow

  • Editing Item Properties

  • Using the Add-In

  • Getting Code from Visual Studio into Total .NET SourceBook

  • Getting Code into Visual Studio .NET


Navigator Toolwindow

When the Total .NET SourceBook Add-In is loaded, the SourceBook Navigator toolwindow appears:

SourceBook Navigator Toolwindow

By default, the toolwindow shows the FMSCode.mdb database that is loaded in the Code Explorer. If FMSCode.mdb is not loaded in the Code Explorer, the toolwindow shows the last code database that was opened through the Code Explorer. The Code Navigator treeview allows you to view, edit, delete, and search for code items and notes. It also allows you to export code directly into your Visual Studio .NET project.

Total .NET SourceBook does not allow you to create, open, or close code databases in Add-In mode. Use the Code Explorer to create, open, or close code databases.

Note that after creating, opening, or closing code databases, you must close the Code Explorer, and refresh the Add-In to reload the last code database that you opened.

See Managing Multiple Code Databases for details.

Moving and Docking the Toolwindow

The first time you start Visual Studio .NET after installing Total .NET SourceBook, the toolwindow appears in undocked mode. You can move the toolwindow around within the IDE, or dock it to any of the dockable positions on the screen. The Total .NET SourceBook toolwindow behaves exactly the same as all built-in Visual Studio .NET toolwindows.

Toolbar Items

The main toolbar contains launch points for the Add-In top-level functionality:

The Total .NET SourceBook Toolbar

Action | Description
View Code | Opens the SourceBook Item Preview toolwindow for viewing and editing code.
View Notes | Opens the SourceBook Item Notes toolwindow for viewing and editing notes.
Refresh | Refreshes the Code Treeview to get the latest version and keep it in sync with the Code Explorer.
Expand All | Expands treeview nodes to show all code.
Collapse All | Collapses treeview nodes.
Find Text/Go | Performs a search for the specified text, and shows the results in the Search Results toolwindow. Note that this performs a simple string search. The code Explorer includes an Advanced Search tool with additional options.
Paste Code into Visual Studio | Pastes the code from the SourceBook Item Preview into your project at the cursor location

The Code Treeview

The code treeview shows the code database that is loaded, with icons to differentiate between item types (see The Treeview for more information). The treeview offers the following options for viewing and organizing code:

  • View code and notes
    Highlight the item in the treeview, and click the View Code [image] or View Notes [image] button on the toolbar (or right-click and choose View Code or View Notes). See Item Preview Toolwindow for details.

  • Delete items
    Right-click on the item, and choose Delete Item from the menu.

  • Move and copy code items
    Click on an item and drag it into the desired location.

  • Paste the code into your project
    Highlight the item in the treeview, and click the Paste [image] button on the toolbar.

See also:

  • How Total .NET SourceBook Integrates with Visual Studio .NET

  • Launching the Add-In

  • Item Preview Toolwindow

  • Item Notes Toolwindow

  • Search Results Toolwindow

  • Editing Item Properties

  • Using the Add-In

  • Getting Code from Visual Studio into Total .NET SourceBook

  • Getting Code into Visual Studio .NET


Item Preview Toolwindow

When you press the View Code [image] button from the SourceBook Navigator toolwindow, the SourceBook Item Preview toolwindow appears:

SourceBook Item Preview Toolwindow

This toolwindow shows the code for the item that you have highlighted in the Code Treeview (in the SourceBook Navigator toolwindow). From this toolwindow, you can add new code, or review and edit existing code. You can also add the code directly to your project—see Getting Code into Visual Studio NET for details!

Code Tabs

The code tabs appear below the information section:

Item Preview Toolwindow, Code Tabs

The code tabs display the item’s code, and allow you to organize your code by language. Tabs containing code are displayed with the [image] icon, so you can easily identify where your code is stored.

See also:

  • How Total .NET SourceBook Integrates with Visual Studio .NET

  • Launching the Add-In

  • Navigator Toolwindow

  • Item Notes Toolwindow

  • Search Results Toolwindow

  • Editing Item Properties

  • Using the Add-In

  • Getting Code from Visual Studio into Total .NET SourceBook

  • Getting Code into Visual Studio .NET


Item Notes Toolwindow

When you press the View Notes [image] button from the SourceBook Navigator toolwindow, the SourceBook Item Notes toolwindow appears:

SourceBook Item Notes Toolwindow

This toolwindow shows the notes for the item that you have highlighted in the Code Treeview (in the SourceBook Navigator toolwindow). From this toolwindow, you can add new notes, or review and edit existing notes. Formatting options are available from the toolbar:

Item Notes Toolbar

See also:

  • How Total .NET SourceBook Integrates with Visual Studio .NET

  • Launching the Add-In

  • Navigator Toolwindow

  • Item Preview Toolwindow

  • Search Results Toolwindow

  • Editing Item Properties

  • Using the Add-In

  • Getting Code from Visual Studio into Total .NET SourceBook

  • Getting Code into Visual Studio .NET


Search Results Toolwindow

When you perform a search from the SourceBook Navigator toolwindow, the SourceBook Search Results toolwindow appears:

SourceBook Search Results Toolwindow

Click on an item in the Results window, and you will be taken to that code item in the Navigator toolwindow.

Double Clicking the item will show the code in the Item preview toolwindow if it is not already open.

See also:

  • How Total .NET SourceBook Integrates with Visual Studio .NET

  • Launching the Add-In

  • Navigator Toolwindow

  • Item Preview Toolwindow

  • Item Notes Toolwindow

  • Editing Item Properties

  • Using the Add-In

  • Getting Code from Visual Studio into Total .NET SourceBook

  • Getting Code into Visual Studio .NET


Editing Item Properties

You can edit code properties using the Visual Studio .NET Properties window. Simply view the properties window (choose View, Properties Window from the Visual Studio .NET menu), and highlight an item in the Navigator toolwindow treeview. The properties window shows all configurable properties for the item:

The Properties Window

See also:

  • How Total .NET SourceBook Integrates with Visual Studio .NET

  • Launching the Add-In

  • Navigator Toolwindow

  • Item Preview Toolwindow

  • Item Notes Toolwindow

  • Search Results Toolwindow

  • Using the Add-In

  • Getting Code from Visual Studio into Total .NET SourceBook

  • Getting Code into Visual Studio .NET


Using the Add-In

The Total .NET SourceBook Add-In makes it easy to move code between your code database and Visual Studio .NET. Simply drag and drop from your code into Total .NET SourceBook, and from Total .NET SourceBook into Visual Studio .NET!

See also:

  • How Total .NET SourceBook Integrates with Visual Studio .NET

  • Launching the Add-In

  • Navigator Toolwindow

  • Item Preview Toolwindow

  • Item Notes Toolwindow

  • Search Results Toolwindow

  • Editing Item Properties

  • Getting Code from Visual Studio into Total .NET SourceBook

  • Getting Code into Visual Studio .NET


Getting Code into Visual Studio .NET

Total .NET SourceBook allows you to add code directly into your Visual Studio .NET project in two ways:

Through the Item Preview Toolwindow: Locate the desired code in the SourceBook Item Preview toolwindow, and use the right-click menu to choose Insert in Project. The code is inserted in your project at the location of the cursor.

Through the Navigator Toolwindow: Locate the desired code item in the SourceBook Navigator toolwindow. With the item highlighted in the Treeview, press the Paste Into Visual Studio button: on the toolbar, and the code is inserted in your project at the location of the cursor.

Note that the code that the code that is inserted into your project is the code from the tab that you are currently viewing in the Item Preview toolwindow. Be sure that you are viewing the appropriate language tab in the Item Preview toolwindow prior to inserting the code into your project.

See also:

  • How Total .NET SourceBook Integrates with Visual Studio .NET

  • Launching the Add-In

  • Navigator Toolwindow

  • Item Preview Toolwindow

  • Item Notes Toolwindow

  • Search Results Toolwindow

  • Editing Item Properties

  • Using the Add-In

  • Getting Code into Visual Studio .NET


Getting Code from Visual Studio into Total .NET SourceBook

To get code from Visual Studio .NET into Total .NET SourceBook, just drag and drop it into the Item Preview toolwindow or the treeview. To drag code into the Item Preview toolwindow, simply highlight it in the editor, and drag it into the toolwindow.

To drag the code into the treeview, highlight the code and drag it into a folder in the treeview. A new item appears in the Treeview with the name "Copied from Visual Studio Editor":

Item Dragged to Treeview

To change the name, edit the item properties.

You can also drag entire classes and modules from the Solution Explorer into the treeview—again, just drag and drop!

See also:

  • How Total .NET SourceBook Integrates with Visual Studio .NET

  • Launching the Add-In

  • Navigator Toolwindow

  • Item Preview Toolwindow

  • Item Notes Toolwindow

  • Search Results Toolwindow

  • Editing Item Properties

  • Using the Add-In

  • Getting Code from Visual Studio into Total .NET SourceBook


Code Webservice Overview

FMS periodically releases new code to Total .NET SourceBook users through the Code Webservice. Every time you start the Code Explorer, a process runs in the background and attempts to contact the Webservice. Because this process runs in the background, it allows you to use Total .NET SourceBook without waiting for the process to complete.

Note that you must have an active Internet connection in order to contact the Code Webservice. If you have a high-speed connection, this process will be relatively fast. If you have a slower connection, such as a modem, please note that the process will take a little more time.

Once a connection is established, Total .NET SourceBook queries the Webservice and returns a list of new code available since your last download. This list is displayed the Start Page:

List of New Webservice Content

This list shows only items that are new since the last time you downloaded content. If you need to retrieve old content, reset the Code Webservice date.

See also:

  • Privacy and Security Notice

  • Downloading Code

  • Organizing the Code

  • Retrieving Earlier Webservice Content

  • Troubleshooting Code Webservice Errors


Privacy and Security Notice

When you access the FMS Code Webservice, certain data from your computer is sent to FMS for the sole purpose of verifying your SOFTWARE license. This information includes your computer name, your registered user name and organization, and your serial number. The data collected is used only for license verification purposes, and is not distributed outside of FMS.

See also:

  • Code Webservice Overview

  • Downloading Code

  • Organizing the Code

  • Retrieving Earlier Webservice Content

  • Troubleshooting Code Webservice Errors


Downloading Code

To import the latest code, click "Download New Content" from the Start page, choose Search, Code Webservice from the menu, or click on the [image] icon on the toolbar. A preview form appears with the name, description, date, and size of each item in the Webservice:

Import From Code Webservice

After reviewing the items available, press the Download all new content button to add all items to your database.

When you press the Download all new content button, all items are downloaded. The Webservice does not allow you to download only a subset of the available items. Keep in mind, however, that you can always delete unwanted items from the Code Database after they are downloaded. See Organizing the Code for details.

When the download is complete, the Download Status field updates with the location of the content:

Webservice Download Complete

If there were errors during the process, they are also listed in this field. See the Troubleshooting Code Webservice Errors for more information.

When you download content from the Code Webservice, it is automatically placed in the Code Database that appears first in the Code Explorer treeview. After downloading the code, you should generally review it and move or copy it to an appropriate location. See Organizing the Code for more information.

See also:

  • Code Webservice Overview

  • Privacy and Security Notice

  • Organizing the Code

  • Retrieving Earlier Webservice Content

  • Troubleshooting Code Webservice Errors


Organizing the Code

When you download code from the Webservice, it is added to the Code Database that appears first in the Code Explorer Treeview. For instance, in the following example, the content would be downloaded to the database named "Alison’sCode.mdb" since it appears first in the list:

Treeview Example

Within that Code Database, Total .NET SourceBook creates a folder named "FMS Code Webservice Downloaded", and within that folder, Total .NET SourceBook creates a subfolder with the download date. The downloaded code items are added to that subfolder:

Webservice Download Treeview Structure

In general, you will want to review the downloaded content and move it to an appropriate location. Just like any other item in the treeview, downloaded items can be moved, renamed, edited, or deleted.

See also:

  • Code Webservice Overview

  • Privacy and Security Notice

  • Downloading Code

  • Retrieving Earlier Webservice Content

  • Troubleshooting Code Webservice Errors


Retrieving Earlier Webservice Content

When you download code from the Webservice, Total .NET SourceBook records the date. This keeps you from seeing code that you have already downloaded and from getting the same code multiple times. The items that show on the Start Page are items that are new since the last time you downloaded from the Webservice.

There may be times, however, when you need to reset this date to retrieve earlier content. For instance, if you inadvertently remove downloaded code, you may want to download it again. If for any reason you want to access code that you have already downloaded, you will need to change the Webservice date. To do this, choose Tools, Settings from the menu, and change the date on the General tab:

Reset Code Webservice Date

See also:

  • Code Webservice Overview

  • Privacy and Security Notice

  • Downloading Code

  • Organizing the Code

  • Troubleshooting Code Webservice Errors


Troubleshooting Code Webservice Errors

If Total .NET SourceBook encounters an error connecting to the Webservice or downloading content, an error message will appear in the Code Webservice Dialog:

Webservice Error

Below is a list of common error conditions and how to solve them:

Error Condition | Resolution
The FMS Code Webservice is down for maintenance. Please try again later. | Try contacting the FMS Code Webservice at a later time.
Could not connect to the FMS Code Webservice. Please ensure you have a valid connection to the internet and try again. | Please verify that you have an active connection to the Internet.
Could not connect to the FMS Code Webservice. Your product installation is invalid. (Error 0010, 0011, 0012). | Please contact: support@fmsinc.com

If the suggestions listed above do not resolve your issue or you are receiving an error not listed here, please review the Support Resources for more information, or email our Technical Support department at support@fmsinc.com.

See also:

  • Code Webservice Overview

  • Privacy and Security Notice

  • Downloading Code

  • Organizing the Code

  • Retrieving Earlier Webservice Content

  • Troubleshooting Code Webservice Errors


Support Resources

There are many resources available to help you resolve issues you may encounter. Please check the following:

Webservice Troubleshooting Tips

If you encounter an error connecting to the Code Webservice, please refer to Troubleshooting Code Webservice Errors.

Readme File

Check the README file for the latest product information. The README file can be opened from the directory where you installed the product.

Product Documentation

We’ve spent a great deal of care and time to make sure the Total .NET SourceBook User Guide is very detailed. Check the Contents and Index for your question, and then read the appropriate sections.

See also:

  • Web Site Support

  • Contacting Technical Support


Web Site Support

The FMS web site contains extensive resources to help you use our products better. Resources include product updates, frequently asked questions (also known as FAQs), newsgroups, information on new versions, betas, and other resources.

Home Page

The FMS home page is located at:

www.fmsinc.com

News and important announcements are posted here.

Support Site

The main support page is located at:

www.fmsinc.com/support

From this page, you can quickly locate the other support resources.

Product Updates

FMS takes product quality very seriously. When bugs are reported and we can fix them, we make the updates available on our web site. If you are encountering problems with our product, make sure you are using the latest version.

Frequently Asked Questions (FAQs)

Additional information is often available from our FAQs.

Newsgroups

FMS also has general and product specific newsgroups. Connect with FMS Technical Support and other users there. Share your experiences, learn from others, and ask your questions in our virtual community:

www.fmsinc.com/support/newsgrp.htm

Or visit our web site for additional information.

Microsoft Patches

Our support site also includes links to Microsoft patches that are related to our products. Make sure you’re using the latest versions by checking here or visiting the Microsoft site.

See also:

  • Support Resources

  • Contacting Technical Support


Contacting Technical Support

Contacting Technical Support

If the troubleshooting suggestions and other support resources fail to resolve your problem, please contact our technical support department. We are very interested in making sure you are satisfied with our product.

Registering Your Software

Please register your copy of Total .NET SourceBook. You must be registered to receive technical support. Registration also entitles you to free product updates, notifications, information about upcoming products, and beta invitations. You can even receive free email notification of our latest news.

You may register your software by mailing in your registration card or directly on our web site.

Contact Us

The best way to contact us is via email at:

Support@fmsinc.com

Please provide detailed information on the problem. This should include the name of the product, version, your operating system, and the specific problem. If the product generated an error file, please submit that as well.

With email, technical support issues can be more accurately resolved and tracked in our internal technical support system. It also gives us more time to understand the entire problem and allows our technical support staff to contact the developers with the entire story when necessary. Please bear in mind that a unique issue may involve meetings between the technical support staff and product developers, so your patience is appreciated.

Microsoft Technical Support

FMS only provides technical support for its products. If you have questions regarding Microsoft products, please contact Microsoft technical support.

See also:

  • Support Resources

  • Web Site Support


License Agreement

PLEASE READ THE FMS SOFTWARE LICENSE AGREEMENT. YOU MUST AGREE TO BE BOUND BY THE TERMS OF THIS AGREEMENT BEFORE YOU CAN INSTALL OR USE THE SOFTWARE.

IF YOU DO NOT ACCEPT THE TERMS OF THE LICENSE AGREEMENT FOR THIS OR ANY FMS SOFTWARE PRODUCT, YOU MAY NOT INSTALL OR USE THE SOFTWARE. YOU SHOULD PROMPTLY RETURN ANY FMS SOFTWARE PRODUCT FOR WHICH YOU ARE UNWILLING OR UNABLE TO AGREE TO THE TERMS OF THE FMS SOFTWARE LICENSE AGREEMENT FOR A REFUND OF THE PURCHASE PRICE.

Ownership of the Software

The enclosed software program ("SOFTWARE") and the accompanying written materials are owned by FMS, Inc. or its suppliers and are protected by United States copyright laws, by laws of other nations, and by international treaties. You must treat the SOFTWARE like any other copyrighted material except that you may make one copy of the SOFTWARE solely for backup or archival purpose, and you may transfer the SOFTWARE to a permanent storage device.

Grant of License

The SOFTWARE is available in a single user license version. You may purchase additional licenses by contacting FMS, Inc.

For each license purchased, you are permitted (either as an individual, or if an entity, one designated individual) to use the program on one computer at a time.

Redistributable Components

Only the Library Code included in the SOFTWARE may be redistributed. Library Code is defined as the programming code that is available when using the SOFTWARE program’s Code Explorer interface. You are specifically prohibited from redistributing any other file or part of the SOFTWARE.

Use and Redistribution Rights

FMS grants you the right to distribute the Library Code on a non-exclusive, royalty free basis, provided that:

  1. Each developer using the program owns a license of the SOFTWARE.

  2. You do not distribute the library code, in whole or in part, in any form that does not add primary and substantial value to the library code.

  3. You do not distribute the library code in an application that is similar in nature or purpose to the SOFTWARE.

  4. You agree to indemnify, hold harmless, and defend FMS and its suppliers or contractors from and against any claims or lawsuits, including attorneys’ fees, that arise or result from the use or distribution of or other activities relating to your software.

  5. If you claim a copyright, you must add a clause stating "Portions of this program are Copyright Total .NET SourceBook from FMS, Inc." and that you do not claim ownership of the SOFTWARE.

Publishing Library Code

You are prohibited from publishing library code on any medium, including, but not limited to, electronic mail, online services, internet newsgroups, and printed matter, except when library code is distributed in an application that adds substantial value to the library code and that application is not similar in nature or purpose to the SOFTWARE.

The Library Code may not be included in freeware or shareware applications in a non-compiled state.

Code Webservice – Information Collected by FMS

When you access the FMS Code Webservice, certain data from your computer is sent to FMS for the sole purpose of verifying your SOFTWARE license. This information includes your computer name, your registered user name and organization, and your serial number. The data collected is used only for license verification purposes, and is not distributed outside of FMS. See Privacy and Security Notice for details.

Restrictions

You may not reverse engineer, de-compile, or disassemble this SOFTWARE. The SOFTWARE is licensed as a single product and may not be separated by use for more than one user at a time. You may not rent or lease the SOFTWARE. You may not transfer any of your rights under the FMS Software License Agreement to other individuals or entities. Without prejudice to any other rights, FMS may terminate this FMS Software License Agreement at any time if you fail to comply with any of its terms. In such an event of termination, you must destroy and stop using all affected SOFTWARE copies.

Transfer of License

If your SOFTWARE is marked "NOT FOR RESALE," you may not sell or resell the SOFTWARE, nor may you transfer the FMS Software license.

If your SOFTWARE is not marked "NOT FOR RESALE," you may transfer your license of the SOFTWARE to another user or entity provided that

  1. You have not used any of the library code in an application.

  2. The recipient agrees to all terms of the FMS Software License Agreement.

  3. You provide all original materials including software disks or compact disks, and any other part of the SOFTWARE’s physical distribution to the recipient.

  4. You remove all installations of the SOFTWARE.

  5. You notify FMS, in writing, of the ownership transfer.

Technical Support on Library Code

Because of the complexity of software development, FMS does not provide technical support related to the use of the Library code in your applications. Technical support is available for issues you find on the Code Explorer application and issues with the included Library Code and associated documentation.

Limited Warranty

If you discover physical defects in the media on which this SOFTWARE is distributed, or in the related manual, FMS, Inc. will replace the media or manual at no charge to you, provided you return the item(s) within 60 days after purchase.

ALL IMPLIED WARRANTIES ON THE MEDIA AND MANUAL, INCLUDING IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE LIMITED TO SIXTY (60) DAYS FROM THE DATE OF PURCHASE OF THIS PRODUCT.

Although FMS, Inc. has tested this program and reviewed the documentation, FMS, Inc. makes no warranty or representation, either expressed or implied, with respect to this SOFTWARE, its quality, performance, merchantability, or fitness for a particular purpose. As a result, this SOFTWARE is licensed "AS-IS", and you are assuming the entire risk as to its quality and performance.

IN NO EVENT WILL FMS, INC. BE LIABLE FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES RESULTING FROM THE USE, OR INABILITY TO USE THIS SOFTWARE OR ITS DOCUMENTATION. THE WARRANTY AND REMEDIES SET FORTH IN THIS LIMITED WARRANTY ARE EXCLUSIVE AND IN LIEU OF ALL OTHERS, ORAL OR WRITTEN, EXPRESSED OR IMPLIED.

Some states do not allow the exclusion or limitation of implied warrantees or liability for incidental or consequential damages, so the above limitations or exclusions may not apply to you. This warranty gives you specific legal rights; you may also have other rights that vary from state to state.

U.S. Government Restricted Rights

The SOFTWARE and documentation are provided with RESTRICTED RIGHTS. Use, duplication, or disclosure by the Government is subject to restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in Technical Data and Computer Software clause at DFARS 252.227-7013 or subparagraphs (c) (1) and (2) of the Commercial Computer Software - Restricted Rights at 48 CFR 52.227-19, as applicable.

Manufacturer is FMS Inc., Vienna, Virginia.
Printed in the USA.

Total .NET SourceBook is copyright Ó 1996-2002 by Financial Modeling Specialists, Inc.
All rights reserved.
Microsoft, Windows, Visual Studio .NET, Visual Basic, C#, and VB are registered trademarks of Microsoft Corporation.
All other trademarks are trademarks of their respective owners.


Code Databases

Total .NET SourceBook ships with a wide variety of code for you to learn from and include in your own applications. All of this code is fully editable, so you can customize it to meet your needs. Additionally, you can use Total .NET SourceBook to manage your own code, making it easy to view and search with the Code Explorer. This section provides details on managing code in Total .NET SourceBook.

See also:

The Importance of Backups

Administrative Tools

Total .NET SourceBook Code Style

Exporting To and Importing From XML

Exporting Code to a File

Importing Code From a File

Adding Your Own Items

Adding New Databases

Adding New Folders

Adding New Items

Editing and Deleting Items

Managing Multiple Code Databases

Searching Code Databases


Database Maintenance

  • The Importance of Backups

  • Administrative Tools

See also:

  • The Importance of Backups

  • Administrative Tools

  • Total .NET SourceBook Code Style

  • Exporting To and Importing From XML

  • Exporting Code to a File

  • Importing Code From a File

  • Adding Your Own Items

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases


Installing Total .NET SourceBook

Total .NET SourceBook comes with an automated setup program to get you up and running as quickly as possible. This chapter describes Total .NET SourceBook’s system requirements, installation steps, and instructions for uninstalling.

See also:

  • System Requirements

  • Installing the Program

  • Check for Updates

  • Uninstalling the Program


Introduction

Total .NET SourceBook provides the knowledge you need to get up to speed on .NET programming quickly. The sophisticated Code Explorer makes finding and organizing code a snap, and the Total .NET SourceBook add-in makes it simple to view, search, and add code to your projects without leaving Visual Studio .NET. You can even add code and notes from your own projects, from other developers, or from our new Code Webservice.

See also:

  • Start Page

  • What Is Total .NET SourceBook?

  • Why Use Total .NET SourceBook?

  • Visit our Web Site


The Add-In Toolwindows

See also:

  • Navigator Toolwindow

  • Item Preview Toolwindow

  • Item Notes Toolwindow

  • Search Results Toolwindow


The Code Explorer

The user interface of Total .NET SourceBook is designed to be as intuitive as possible. The Code Explorer is the product’s command center—it organizes your code and provides access to all of the available functionality. This section provides details about each portion of the Code Explorer.

See also:

Running the Program

The Start Page

The Menu and Toolbar

File Menu

Edit Menu

View Menu

Search Menu

Tools Menu

Help Menu

The Treeview

Code Items

Organizing the Code

Right-Click Menu

The Details Pane

Information Section

Code Tabs

Notes

Details

The Search Results


The Code Webservice

FMS periodically releases new code to Total .NET SourceBook users through the Code Webservice. This section provides information on obtaining new code through the Webservice, as well as troubleshooting tips for common problems.

See also:

  • Code Webservice Overview

  • Privacy and Security Notice

  • Downloading Code

  • Organizing the Code

  • Retrieving Earlier Webservice Content

  • Troubleshooting Code Webservice Errors


The Total .NET SourceBook Add-In

In addition to the standalone Code Explorer, Total .NET SourceBook runs as an add-in to Microsoft Visual Studio .NET. The Total .NET SourceBook add-in is automatically loaded into the IDE when you run Visual Studio .NET, providing you with easy access to Total .NET SourceBook code directly through your development environment. This section provides details about how the Total .NET SourceBook Add-In works.

See also:

  • How Total .NET SourceBook Integrates with Visual Studio .NET

  • Launching the Add-In

  • Navigator Toolwindow

  • Item Preview Toolwindow

  • Item Notes Toolwindow

  • Search Results Toolwindow

  • Editing Item Properties

  • Using the Add-In

  • Getting Code from Visual Studio into Total .NET SourceBook

  • Getting Code into Visual Studio .NET


Troubleshooting and Support

This section provides information on troubleshooting problems that arise and obtaining support for Total .NET SourceBook.


Using the Included Code

Total .NET SourceBook Code Style

Exporting To and Importing From XML

Exporting Code to a File

Importing Code From a File

See also:

  • The Importance of Backups

  • Administrative Tools

  • Total .NET SourceBook Code Style

  • Exporting To and Importing From XML

  • Exporting Code to a File

  • Importing Code From a File

  • Adding Your Own Items

  • Editing and Deleting Items

  • Managing Multiple Code Databases

  • Searching Code Databases